/*
 * This module is an X11 specific part for the BSX client
 * It reads the keyboard, and processes the chars.
 * Upon reception of CR, the chars get send to the bsx server.
 * Reading the keyboard isn't easy at all in X, that's why
 * the code is pretty extensive.
 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

extern int mud_socket;
extern char logging;
extern Display *dpy;
extern Window win;
extern void add_char_to_prompt_line();
extern void add_char_to_text_window();
extern void tell_server();

char key_strokes[1000];
int fill=0;

/*
 * This routine is contains the code for the producer's process.
 * It reads the keyboard, and acts accordingly.
 */
void spit_char(event)
  XEvent event;
{
  char c;
  KeySym k;
  char buffer[10];
  XComposeStatus compose;

  XLookupString((XKeyEvent *) &event,buffer,10,&k,&compose);
  c = buffer[0];
  if ((k >= XK_Shift_L) && (k <= XK_Hyper_R)) {
    return;   /* Modifier key -> do nothing */
  }
  if (k==XK_BackSpace || k==XK_Delete) {
    if (fill)
      fill--;
    add_char_to_prompt_line(8);
    return;
  } 
  if (k==XK_Return) {
    key_strokes[fill++] = '\n';
    write(mud_socket, key_strokes, fill);
    key_strokes[fill] = 0;
    add_char_to_prompt_line(c);
    add_char_to_text_window(c);
    fill = 0;
    return;
  }
  if (k==XK_Left) {
    tell_server("micro_w\n");
    return;
  }
  if (k==XK_Right) {
    tell_server("micro_e\n");
    return;
  }
  if (k==XK_Up) {
    tell_server("micro_n\n");
    return;
  }
  if (k==XK_Down) {
    tell_server("micro_s\n");
    return;
  }
  if ((k>=XK_space) && (k<=XK_asciitilde)) {
    key_strokes[fill++] = c;
    add_char_to_prompt_line(c);
    return;
  }
}

